import java.util.Arrays; 

public class Test {

	public static void main(String[] args) {
		Object array[] = new String[5];
		array[0] = new String("Roberto");
		array[1] = new String("Barbara");
		array[2] = new String("Alice");
		array[3] = new String("Saverio");
		array[4] = new String("Carlo");
		//sort(Object[] a) sorts the specified array of objects into ascending order, 
		//according to the natural ordering of its elements.
		//Quicksort is used for arrays of primitive types while mergesort for Object[] arrays.
		Arrays.sort(array);
		for (int i=0; i<array.length; i++) System.out.print(array[i] + "; ");

		/* binarySearch returns:
		 * - the index of the search key, if it is contained in the array; 
		 * - otherwise, (-(insertion point)  1).
		 * - The insertion point is defined as the point at which the key would
		 * be inserted into the array:
		 * the index of the first element greater than the key, or
		 * a.length if all elements in the array are less than the specified key. 
		 * The return value will be >= 0 if and only if the key is found.
		 */
		String s=new String("Barbara");
		int index = Arrays.binarySearch(array, s);
		System.out.println("\n" + s + " found at index = " + index); 
		
		s=new String("Luca");
		index = Arrays.binarySearch(array, s);
		System.out.println(s + " found at index = " + index); 
		
	    array = new Punto[4];
	    array[0]= new Punto(30,40);
	    array[1]= new Punto(300,400);
	    array[2]= new Punto(3,4);
	    array[3]= new Punto(30,40);
	    
		Arrays.sort(array);
		System.out.println();
		for (int i=0; i<array.length; i++) System.out.print(array[i] + "; ");
		System.out.println();

		array = new ContoCorrente[4];
	    array[0]= new ContoCorrente("Giovanna Neri", 4000);
	    array[1]= new ContoCorrente("Luca Rossi");
	    array[2]= new ContoCorrente("Mario Bianchi", 5500);
	    array[3]= new ContoCorrente("Alice Verdi", 2500.50);
	    
		Arrays.sort(array);
		System.out.println();
		for (int i=0; i<array.length; i++) System.out.println(array[i] + "; ");
		
	}

}
